'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = createLitMaterial;

var _glShader = require('gl-shader');

var _glShader2 = _interopRequireDefault(_glShader);

var _litSetUniforms = require('./lit-set-uniforms');

var _litSetUniforms2 = _interopRequireDefault(_litSetUniforms);

var _litSetAttributes = require('./lit-set-attributes');

var _litSetAttributes2 = _interopRequireDefault(_litSetAttributes);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _useAugment = require('../common/use-augment');

var _useAugment2 = _interopRequireDefault(_useAugment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fragSource = require('fs').readFileSync(__dirname + '/lit.built.frag', 'utf8'); // Browserify Transforms:
var vertSource = require('fs').readFileSync(__dirname + '/lit.built.vert', 'utf8');

function LitMaterial(shadingConfig) {

	this.flags = {
		visible: true,
		transparent: false,
		recompile: true
	};

	this.fragSource = fragSource;
	this.vertSource = vertSource;

	this.defines = ["CAMERA", "NORMAL"];
	this.shader = null;
	this.mode = "TRIANGLES";
	this.setUniforms = [_litSetUniforms2.default];
	this.setAttributes = [_litSetAttributes2.default];
	this.shading = shadingConfig;

	this.use = _useAugment2.default.bind(null, this);
}

function createLitMaterial(properties) {

	var shadingConfig = (0, _objectAssign2.default)({
		color: [0.1, 0.1, 0.1],
		opacity: 1.0
	}, properties);

	return new LitMaterial(shadingConfig);
}