'use strict';

var _tape = require('tape');

var _tape2 = _interopRequireDefault(_tape);

var _normals = require('normals');

var _normals2 = _interopRequireDefault(_normals);

var _readPixel = require('../read-pixel');

var _readPixel2 = _interopRequireDefault(_readPixel);

var _mesh = require('../../../lib/mesh');

var _mesh2 = _interopRequireDefault(_mesh);

var _perspective = require('../../../lib/camera/perspective');

var _perspective2 = _interopRequireDefault(_perspective);

var _lit = require('../../../lib/material/lit');

var _lit2 = _interopRequireDefault(_lit);

var _normalColor = require('../../../lib/material/augment/normal-color');

var _normalColor2 = _interopRequireDefault(_normalColor);

var _forward = require('../../../lib/renderer/forward');

var _forward2 = _interopRequireDefault(_forward);

var _scene = require('../../../lib/scene');

var _scene2 = _interopRequireDefault(_scene);

var _geometry = require('../../../lib/geometry');

var _geometry2 = _interopRequireDefault(_geometry);

var _primitiveCube = require('primitive-cube');

var _primitiveCube2 = _interopRequireDefault(_primitiveCube);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _tape2.default)("Normal Color Material", function (t) {

	var scene = (0, _scene2.default)({
		renderer: (0, _forward2.default)({
			autoResizeCanvas: false,
			width: 100,
			height: 100
		})
	});

	var gl = scene.renderer.gl;
	var camera = (0, _perspective2.default)();
	var box = (0, _primitiveCube2.default)(5, 5, 5);
	var geometry = (0, _geometry2.default)(box);
	var mesh;
	camera.transform.position[2] = 20;
	var material = (0, _normalColor2.default)((0, _lit2.default)({ color: [1, 0, 0] }));
	mesh = (0, _mesh2.default)(material, geometry);
	scene.add(mesh);

	t.plan(5);

	mesh.transform.euler[1] = 0;
	scene.render(camera);

	t.deepLooseEqual((0, _readPixel2.default)(gl, 50, 50), [127, 127, 255], "The box's side is purplish.");

	mesh.transform.euler[1] = Math.PI * 0.25;
	scene.render(camera);

	t.deepLooseEqual((0, _readPixel2.default)(gl, 40, 50), [0, 127, 127], "The left is green");
	t.deepLooseEqual((0, _readPixel2.default)(gl, 60, 50), [127, 127, 255], "The box's side is purplish");

	camera.transform.position[2] = -20;
	camera.transform.euler[1] = Math.PI;

	t.deepLooseEqual((0, _readPixel2.default)(gl, 40, 50), [0, 127, 127], "The left is green");
	t.deepLooseEqual((0, _readPixel2.default)(gl, 60, 50), [127, 127, 255], "The box's side is purplish");

	scene.renderer.destroy();
});